<header>
    <p align="center">
        <img alt="logo" src="https://user-images.githubusercontent.com/8976745/211187132-1a5e959b-d3a4-4c84-84c1-f8bd5463a30e.png" width="50%"/>
    </p>
    <p align="center">
        <a href="https://crates.io/crates/punfetch"><img alt="crate" src="https://img.shields.io/crates/v/punfetch?style=for-the-badge" /></a>
        <a href="https://crates.io/crates/punfetch"><img alt="downloads" src="https://img.shields.io/crates/d/punfetch?style=for-the-badge" /></a>
        <a href="./LICENSE"><img alt="license" src="https://img.shields.io/badge/license-MIT-blue?style=for-the-badge" /></a>
        <a href="https://github.com/ozwaldorf/punfetch/actions/workflows/rust.yml"><img alt="ci" src="https://img.shields.io/github/actions/workflow/status/ozwaldorf/punfetch/rust.yml?label=CI&style=for-the-badge" /></a>
        <a href="https://github.com/ozwaldorf/punfetch/actions/workflows/publish.yml"><img alt="publish" src="https://img.shields.io/github/actions/workflow/status/ozwaldorf/punfetch/publish.yml?label=Publish&style=for-the-badge" /></a>
    </p>
    <p align="center">
        A blazingly fast system fetch program to pair with <a href="https://github.com/o2sh/onefetch">onefetch</a>
    </p>
    <hr>
    <p align="center">
        <img alt="preview" width="80%" src="https://user-images.githubusercontent.com/8976745/211231336-194d6836-154b-4189-beac-b022d3056504.png"/> 
    </p>
</header>

---

# Installation

### Install from crates.io

```bash
cargo install punfetch
```

### Build from source

```bash
git clone https://github.com/ozwaldorf/punfetch.git
cd punfetch
make install
```

# Usage

```man
$ punfetch -h
A blazingly fast system fetch designed to replicate the look of onefetch.

Usage: punfetch [OPTIONS]

Options:
      --distro <DISTRO>    Distribution to search art for (e.g. "Manjaro" or "Ubuntu")
  -i, --image <IMAGE>      Image to display in place of the distro art
      --show-logo <WHEN>   Show the logo [default: always] [possible values: always, never, auto]
      --color-mode <MODE>  Color mode to use [default: hex] [possible values: hex, ansi, none]
      --color <COLOR>      Text color to use. Accepts ansi or hex color codes
  -h, --help               Print help
  -V, --version            Print version
```

# Library

Punfetch is also a library to implement custom system fetchers! See [the docs](https://docs.rs/punfetch) for more information and examples.

# Contributing

This project follows [conventional commits](https://www.conventionalcommits.org/en/v1.0.0/)

> ⚠️ Over 200 distributions are already supported, but many do not have colors defined. If your distro is not colored, please open a PR to update it!

## Adding a new distribution

New distributions can easily be supported by adding a new entry to the [distros.yaml](distros.yaml) file

```yaml
"Examplo Linux":
  regex: "(examplo|examplo_old)" # Optional, regex to match against. Autogenerated if not provided.
  colors: # Optional, default fg will be used if not specified
    ansi:
      - white # The first color is used for the info text
      # - bright_green
      # - magenta
      # - etc,
    hex: # Optional, ansi colors will be used if not specified
      - "#ffffff"
  ascii: | # The ascii art to display!
    {0}         _nnnn_
    {0}        dGGGGMMb
    {0}       @p~qp~~qMb
    {0}       M|@||@) M|
    {0}       @,----.JM|
    {0}      JS^\__/  qKL
    {0}     dZP        qKRb
    {0}    dZP          qKKb
    {0}   fZP            SMMb
    {0}   HZM            MMMM
    {0}   FqM            MMMM
    {0} __| ".        |\dS"qML
    {0} |    `.       | `' \Zq
    {0}_)      \.___.,|     .'
    {0}\____   )MMMMMP|   .'
    {0}     `-'       `--'
```

> If there are multiple patterns that could be used to identify the distribution, or the title of the
> distribution is lengthy, a regex should be provided. Patterns should be simple, lowercase, and `A-z`, `0-9` only.

<footer>
    <h2 align="center">Contributors ❤️</h2>
    <h3 align="center">Honorable mentions</h3>
    <p align="center">
        <a href="https://github.com/o2sh">@o2sh</a>
        <a href="https://github.com/spenserblack">@spenserblack</a>
        for creating
        <a href="https://github.com/o2sh/onefetch">onefetch</a>
    </p>
    <p align="center">
        <a href="https://github.com/ozwaldorf/punfetch/graphs/contributors"><img alt="contrib.rocks" src="https://contrib.rocks/image?repo=ozwaldorf/punfetch"/></a>
    </p>
    <p align="center">(<a href="https://contrib.rocks/preview?repo=ozwaldorf%2Fpunfetch">contrib.rocks</a>)</p>
</footer>
